<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    exclude-result-prefixes="xs"
    version="1.0">
    <xsl:output method="xml" indent="yes" />
    <!-- klucz name="name" match="pattern" use="expression" -->
    <xsl:key name="keyPozycjaD" match="/DokumentPlanistyczny/Dokument/Zalaczniki/Dochody/Pozycja" use="concat(./Rozdzial/text(),./Paragraf/text(),./P4/text() )" />
    <xsl:key name="keyPozycjaW" match="/DokumentPlanistyczny/Dokument/Zalaczniki/Wydatki/Pozycja" use="concat(./Rozdzial/text(),./Paragraf/text(),./P4/text() )" />

    <xsl:template name="DokumentPlanistyczny" match="/">
        <DokumentPlanistyczny Wersja="1.0">
            <xsl:copy-of select="/DokumentPlanistyczny/Dokument/Naglowek"/>
            <Zalaczniki>
                <Dochody>
                    <xsl:apply-templates select="/DokumentPlanistyczny/Dokument/Zalaczniki/Dochody/Pozycja"/> 
                </Dochody> 
                <Wydatki>
                    <xsl:apply-templates select="/DokumentPlanistyczny/Dokument/Zalaczniki/Wydatki/Pozycja"/> 
                </Wydatki>
            </Zalaczniki>    
        </DokumentPlanistyczny>
    </xsl:template>  
        
    <xsl:template name="DochodyPozycjeGrupowanie" match="/DokumentPlanistyczny/Dokument/Zalaczniki/Dochody/Pozycja">  
            <xsl:for-each select="
                (self::*[(generate-id(.)=generate-id(key('keyPozycjaD',
                concat(./Rozdzial/text(),./Paragraf/text(),./P4/text() ))[1]))   
             ])">     
            
                <xsl:variable name="keyGroupD" select="key('keyPozycjaD', concat(./Rozdzial/text(),./Paragraf/text(),./P4/text()))"/>
            
               <Pozycja>
                    <Dzial><xsl:value-of select="./Dzial"/></Dzial>
                    <Rozdzial><xsl:value-of select="./Rozdzial"/></Rozdzial>
                    <Paragraf><xsl:value-of select="./Paragraf"/></Paragraf>
                    <P4><xsl:value-of select="./P4"/></P4>
                    <SymbolJednostki><xsl:value-of select="./SymbolJednostki"/></SymbolJednostki>
                    <Rodzaj><xsl:value-of select="./Rodzaj"/></Rodzaj>
                    <NazwaZadania></NazwaZadania>
                    <SymbolZadania></SymbolZadania>
                    <Wartosc><xsl:value-of select="format-number(sum($keyGroupD/Wartosc), '#.00')"/></Wartosc>
              </Pozycja>       
             </xsl:for-each>                               
                  
    </xsl:template>
    
    <xsl:template name="WydatkiPozycjeGrupowanie" match="/DokumentPlanistyczny/Dokument/Zalaczniki/Wydatki/Pozycja">
        
            <xsl:for-each select=".">
            <xsl:choose>
                <xsl:when test="./NazwaZadania != 'Zadania statutowe'">    
                    <Pozycja>   
                        <Dzial><xsl:value-of select="./Dzial"/></Dzial>
                        <Rozdzial><xsl:value-of select="./Rozdzial"/></Rozdzial>
                        <Paragraf><xsl:value-of select="./Paragraf"/></Paragraf>
                        <P4><xsl:value-of select="./P4"/></P4>
                        <SymbolJednostki><xsl:value-of select="./SymbolJednostki"/></SymbolJednostki>
                        <Rodzaj><xsl:value-of select="./Rodzaj"/></Rodzaj>
                        <NazwaZadania><xsl:value-of select="./NazwaZadania"/></NazwaZadania>
                        <SymbolZadania><xsl:value-of select="./SymbolZadania"/></SymbolZadania>
                        <Wartosc><xsl:value-of select="./Wartosc"/></Wartosc>
                    </Pozycja> 
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select="
                        (self::*[(generate-id(.)=generate-id(key('keyPozycjaW',
                        concat(./Rozdzial/text(),./Paragraf/text(),./P4/text() ))[1]))   
                        ])">     
                        
                     <xsl:variable name="keyGroupW" select="key('keyPozycjaW', concat(./Rozdzial/text(),./Paragraf/text(),./P4/text()))"/>
                        
                     <Pozycja>
                          <Dzial><xsl:value-of select="./Dzial"/></Dzial>
                          <Rozdzial><xsl:value-of select="./Rozdzial"/></Rozdzial>
                          <Paragraf><xsl:value-of select="./Paragraf"/></Paragraf>
                          <P4><xsl:value-of select="./P4"/></P4>
                          <SymbolJednostki><xsl:value-of select="./SymbolJednostki"/></SymbolJednostki>
                          <Rodzaj><xsl:value-of select="./Rodzaj"/></Rodzaj>
                          <NazwaZadania><xsl:value-of select="./NazwaZadania"/></NazwaZadania>
                          <SymbolZadania>ZS</SymbolZadania>
                         <Wartosc><xsl:value-of select="format-number(sum($keyGroupW/Wartosc), '#.00')"/></Wartosc>
                      </Pozycja>  
                    </xsl:for-each>                    
                </xsl:otherwise>
            </xsl:choose>
               
        </xsl:for-each> 
        
    </xsl:template>    
    
</xsl:stylesheet>